/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you want to add, delete, or rename functions or slots, use
** Qt Designer to update this file, preserving your code.
**
** You should not define a constructor or destructor in this file.
** Instead, write your code in functions called init() and destroy().
** These will automatically be called by the form's constructor and
** destructor.
*****************************************************************************/

extern "C"{
   #include "mv_phapi.h"
}

extern int fd;
extern int img_width;
extern int img_height;
extern int numitem;
extern int bpp;
//extern int bfield;

int w_th;
//RESIZECALLBACK windowresize;


void getbpp(int numitem)
{
	switch(numitem)
	{
		case 0/*RGB24*/  : 
				bpp = 3;
				break;
		case 1/*RGB8888*/    : 
				bpp = 4;
				break;
		case 2/*RGB565*/ : 
				bpp = 2;
				break;
		case 3/*RGB1555*/    : 
				bpp = 2;
				break;
		case 4/*RGB5515*/    : 
				bpp = 2;
				break;
		case 5/*RGB8332*/    :
				bpp = 1;
				break;
		case 6/*YUV422*/ : 
				bpp = 2;
				break;
   	}
}

void ImageSizeDialog::defaultclick()
{
     WidthSlider->setValue(480);
     HeightSlider->setValue(320);
}

void ImageSizeDialog::cancelclick()
{
     WidthSlider->setValue(width);
     HeightSlider->setValue(height);
     hide();
}


void ImageSizeDialog::okclick()
{
    int bfield;
    if(fd > 0)
    {
    w_th = WidthSlider->value () - (WidthSlider->value () % 8);
    numitem = ColorFormatcomboBox->currentItem();
    getbpp(numitem);
    bfield = FieldcomboBox->currentItem();
    MV_SetDeviceParameter(fd,GRAB_WIDTH,w_th);
    img_width = MV_GetDeviceParameter(fd,GRAB_WIDTH);
    MV_SetDeviceParameter(fd,GRAB_HEIGHT,HeightSlider->value());
    //MV_SetDeviceParameter(fd,GRAB_HEIGHT,img_height);
    img_height = MV_GetDeviceParameter(fd,GRAB_HEIGHT);
     if(bfield == 1 || bfield == 2)
	img_height =  img_height/2;
    MV_SetDeviceParameter(fd,GARB_BITDESCRIBE,ColorFormatcomboBox->currentItem());
    MV_SetDeviceParameter(fd,WORK_FIELD,FieldcomboBox->currentItem());
    (windowresize)();
    }
    hide();    
}

void ImageSizeDialog::init()
{
    width = 480;
    height = 320;
    WidthLCDNum->display(width);
    HeightLCDNum->display(height);
}

void ImageSizeDialog::Width_Changed( int )
{
    w_th = WidthSlider->value () - (WidthSlider->value () % 8);
    
    WidthLCDNum->display( w_th );
}

void ImageSizeDialog::Height_Changed( int )
{
    HeightLCDNum->display( HeightSlider->value() );
}

void ImageSizeDialog::setCallback( RESIZECALLBACK callresize )
{
    windowresize = callresize;
}
